## slimski 1.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6.0 FATAL_ERROR)

set(PROJECT_NAME slimski)
project(${PROJECT_NAME})

###Pretty colors
set(CMAKE_COLOR_MAKEFILE ON)
###Do not force verbose
set(CMAKE_VERBOSE_MAKEFILE ON)
###Include current dir
set(CMAKE_INCLUDE_CURRENT_DIR TRUE)

INCLUDE(CheckIncludeFile)
INCLUDE(CheckCCompilerFlag)
INCLUDE(CheckCXXCompilerFlag)
INCLUDE(CheckTypeSize)

set(SLIMSKI_VERSION_MAJOR "1")
set(SLIMSKI_VERSION_MINOR "5")
set(SLIMSKI_VERSION_PATCH "0")
set(SLIMSKI_VERSION "${SLIMSKI_VERSION_MAJOR}.${SLIMSKI_VERSION_MINOR}.${SLIMSKI_VERSION_PATCH}")

#set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "Installation Directory")
#     howdy     would be overridden by debtools anyhow
#                ref:      debian/rules:41:override_dh_usrlocal
#
#       also: skidoo  removed from debian/slimski.dirs:  usr/local  and  usr/local/bin
set(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Installation Directory")

set(PKGDATADIR "${CMAKE_INSTALL_PREFIX}/share/slimski")
set(SYSCONFDIR "/etc")
set(MANDIR "${CMAKE_INSTALL_PREFIX}/share/man")

set(SLIMSKI_DEFINITIONS)
set(SLIMSKI_DEFINITIONS ${SLIMSKI_DEFINITIONS} "-DPACKAGE=\"slimski\"")
set(SLIMSKI_DEFINITIONS ${SLIMSKI_DEFINITIONS} "-DVERSION=\"${SLIMSKI_VERSION}\"")
set(SLIMSKI_DEFINITIONS ${SLIMSKI_DEFINITIONS} "-DPKGDATADIR=\"${PKGDATADIR}\"")
set(SLIMSKI_DEFINITIONS ${SLIMSKI_DEFINITIONS} "-DSYSCONFDIR=\"${SYSCONFDIR}\"")

### project-specific CFLAGS or CPPFLAGS not needed. Defer to use of the system-specified flags.
#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -g -O2")
#set(CMAKE_CPP_FLAGS "${CMAKE_CPP_FLAGS} -Wall -g -O2")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -g -O2")

### source
set(slimski_srcs
    main.cpp
    app.cpp
    capslock.cpp
    cfg.cpp
    image.cpp
    numlock.cpp
    panel.cpp
    PAM.cpp
    switchuser.cpp
    util.cpp
    log.cpp
)

add_executable(${PROJECT_NAME} ${slimski_srcs})

###Set the custom CMake module directory (where our include/lib finders reside)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

find_package(X11 REQUIRED)
find_package(Freetype REQUIRED)
find_package(JPEG REQUIRED)
find_package(PNG REQUIRED)
#find_package(ZLIB REQUIRED)   # dpkg-shlibdeps warns "none of this library's symbols are used


### Fontconfig    # dpkg-shlibdeps sez "none of this library's symbols are used
set(FONTCONFIG_DIR ${CMAKE_MODULE_PATH})
find_package(FONTCONFIG REQUIRED)
if(FONTCONFIG_FOUND)
    message("\tFontConfig Found")
    target_link_libraries(${PROJECT_NAME} ${FONTCONFIG_LIBRARY})
    include_directories(${FONTCONFIG_INCLUDE_DIR})
endif(FONTCONFIG_FOUND)

message("\tPAM Enabled")
find_package(PAM)
if(PAM_FOUND)
    message("\tPAM Found")
    target_link_libraries(${PROJECT_NAME} ${PAM_LIBRARY})
    include_directories(${PAM_INCLUDE_DIR})
else(PAM_FOUND)
    #    howdy    would be fatal
    message("\tPAM Not Found")
endif(PAM_FOUND)


### system libraries
find_library(M_LIB m)
find_library(RT_LIB rt)

add_definitions(${SLIMSKI_DEFINITIONS})

###Set up include dirs with all found packages
include_directories(
    ${X11_INCLUDE_DIR}
    ${X11_Xft_INCLUDE_PATH}
    ${X11_Xrender_INCLUDE_PATH}   # dpkg-shlibdeps misleadingly warns "none of this library's symbols are used

###     Using FREETYPE_INCLUDE_DIR_freetype2 directly
###       can cause issues with newer freetype packages (it does not contain all freetype include dirs)
#   ${FREETYPE_INCLUDE_DIR_freetype2}
#     ^---v
    ${FREETYPE_INCLUDE_DIRS}   # dpkg-shlibdeps misleadingly warns "none of this library's symbols are used
    ${X11_Xmu_INCLUDE_PATH}
    ${JPEG_INCLUDE_DIR}
    ${PNG_INCLUDE_DIR}
)

set(X11_Xmu_LIB Xmu)
###Set up library with all found packages
target_link_libraries(${PROJECT_NAME}
    ${M_LIB}
    ${RT_LIB}
    ${X11_X11_LIB}
    ${X11_Xft_LIB}
    ${X11_Xrender_LIB}       # dpkg-shlibdeps misleadingly warns "none of this library's symbols are used     howdy bub   retest this
    ${X11_Xmu_LIB}
    ${FREETYPE_LIBRARY}      # dpkg-shlibdeps misleadingly warns "none of this library's symbols are used
    ${JPEG_LIBRARIES}
    ${PNG_LIBRARIES}
    )


####### install                howdy    for debian buster+   usr/bin     https://www.debian.org/releases/stable/amd64/release-notes/ch-whats-new.en.html#merged-usr
install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION bin )

install(FILES doc/slimski.1 DESTINATION ${MANDIR}/man1/)

install(FILES slimski.conf DESTINATION ${SYSCONFDIR})

###  TODO   this hard-coded dirpath may not exist on all target systems
###
###  TODO   check the inconsistent use of trailing slash
###         (vs none, as seen in the CMakeLists.txt residing in subdirs)
install(FILES README DESTINATION /usr/share/doc/slimski/)

add_subdirectory(themes)
add_subdirectory(doc)

=== doc/CMakeLists.txt ===
set (DOC "/usr/share/doc/slimski")

###   https://cmake.org/cmake/help/v3.0/command/install.html?highlight=install%20files
install(FILES  ChangeLog_slimski.txt  COPYING  slimski_OPTIONS_LIST.txt  DESTINATION ${DOC})
install(FILES  pam.sample THEMES  xinitrc.sample  DESTINATION ${DOC})
install(FILES  translations_TEMPLATE.txt  slimski_man.txt  A-Z__theming_optionslist.txt  DESTINATION ${DOC})

=== themes/CMakeLists.txt ===
add_subdirectory(default)
add_subdirectory(ax)
add_subdirectory(flat)

=== themes/ax/CMakeLists.txt ===
set (THEMES "themes/ax")

install(FILES slimski.theme DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES panel.png DESTINATION ${PKGDATADIR}/${THEMES})

=== themes/default/CMakeLists.txt ===
set (THEMES "themes/default")

install(FILES slimski.theme DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES panel.png DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES background.jpg DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES ar_EG  bg_BG  ca_ES  cs_CZ  da_DK  de_AT  de_CH  DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES de_DE  et_EE  en_AU  en_GB  en_NZ  en_US  es_ES  DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES es_AR  es_BO  es_CO  es_EC  es_MX  es_NI  es_PE  DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES es_US  es_UY  es_VE  eu_ES  fa_IR  fr_FR  fr_BE  DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES fr_CA  fr_CH  ka_GE  el_GR  hr_HR  is_IS  it_IT  DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES he_IL  ja_JP  kk_KZ  ko_KR  lv_LV  lt_LT  hu_HU  DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES mk_MK  nl_NL  nl_BE  nb_NO  pl_PL  pt_PT  pt_BR  DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES ro_RO  ru_RU  sq_AL  zh_CN  sk_SK  sl_SI  sr_RS  DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES fi_FI  sv_SE  zh_TW  tr_TR  uk_UA  DESTINATION ${PKGDATADIR}/${THEMES})

=== themes/flat/CMakeLists.txt ===
set (THEMES "themes/flat")

install(FILES slimski.theme DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES panel.png DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES background.png DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES background_.png DESTINATION ${PKGDATADIR}/${THEMES})
install(FILES logo.png DESTINATION ${PKGDATADIR}/${THEMES})

=== debian/changelog ===
slimski (1.5.0-6.0antix2) unstable; urgency=medium

  * added runit scripts

 -- anticapitalista <antix@operamail.com>  Fri, 10 Sep 2021 12:48:13 +0300

slimski (1.5.0-6.0antix1) unstable; urgency=medium

    * Updates from upstream

 -- anticapitalista <antix@operamail.com>  Sun, 08 Aug 2021 11:34:47 +0300

slimski (1.5.0-6~contribs2) unstable; urgency=medium

    * Reset background when login in (only normal login).

 -- Xecure <not@telling.you>  Mon, 23 Aug 2021 11:30:08 +0200

slimski (1.5.0-6~contribs1) unstable; urgency=medium

    * Fixed bug: Lastused session (with spaces) could not be read

 -- Xecure <not@telling.you>  Mon, 09 Aug 2021 11:30:08 +0200

slimski (1.5.0-5~contribs1) unstable; urgency=medium

    * Fixed bug: Not loading lastused when using xsessionsdir
    * slimski preconfigured to work with any Debian based Linux Distro
    * Reads /usr/share/Xsessions folder searching for valid sessions
    * Removed dbus as pre-requisite for init script
    * Removed testing txt options in default theme
    
    Debian control configuration: 
    * Changed elogind enforcement dependency. Alt: Consolekit and logind
    * Changed dbus to recommend (not enforced dependency) - testing

 -- Xecure <not@telling.you>  Sun, 08 Aug 2021 13:53:07 +0200

slimski (1.5.0-4.0antix2) unstable; urgency=medium

  * Changed default thee to remove cust messages on screen
  * default login in /etc/slimski.conf set to Xsession
  * remove hard dependency on elogind and dbus

 -- anticapitalista <antix@operamail.com>  Sun, 08 Aug 2021 11:34:47 +0300

slimski (1.5.0-4.0antix1) unstable; urgency=medium

  * antiX build 

 -- anticapitalista <antix@operamail.com>  Sat, 31 Jul 2021 21:51:30 +0300

slimski (1.5.0-4~contribs1) unstable; urgency=medium

    * Fixed numlock disble to work even if the option is commented out
    * Fixed the missing LANG environment variable causing segfault error
    * Removed NONE theme.

 -- Xecure <not@telling.you>  Tue, 20 Jul 2021 21:25:54 +0200

slimski (1.5.0-3~contribs1) unstable; urgency=medium

    * Fixed numlock enable not working when autologin is enabled

 -- Xecure <not@telling.you>  Fri, 16 Jul 2021 13:23:21 +0200

slimski (1.5.0-2~contribs1) unstable; urgency=medium

    * Fixed locale theme loading (not only for testing)
    * If BLANG check fails, move down to LANG check (for daemonmode).
    * Edited slimski.conf default desktop-session (to rox-icewm)

 -- Xecure <not@telling.you>  Sat, 10 Jul 2021 23:27:54 +0200

slimski (1.5.0-1~contribs1) unstable; urgency=medium

    * Updated 5 languages for default themes
    * Commented out line bl=$(cat /proc/cmdline) in slimski.init

 -- Xecure <not@telling.you>  Sun, 20 Jun 2021 19:11:47 +0200

slimski (1.5.0~b2) unstable; urgency=medium
    * will cleanup this changelog later
    * noted: the following would need to be changed (replaced) in antiX
       /usr/local/share/live-files/files/etc/init.d/slim
       /usr/local/share/live-files/files/etc/init.d/debian/slim
       /usr/local/share/live-files/general-files/etc/slim.conf
    * dpkg-query: no path found matching pattern /etc/init.d/debian/slim
          To inject an equivalent replacement,
          build-iso would need to be modified (I'm guessing)
    * runCommand() which execs the optionally-configured F2--F12 commands
      as well as the popfirst_cmd does DROP PRIVILEGES when launching

 -- skidoo <email@redact.ed>  Tue, 02 Feb 2021 12:34:56 +0100

slimski (1.5.0~b1) unstable; urgency=medium
    * recheck: is the program yet WRITING a lastused file?
    * TODO    explore options for "fullscreen" helpdoc presentation program, bound to Fkey
    * todo: move, or duplicate, some of the conditional zeebug output to LOGSTREAM (tee?)
    * needs tested:   whatif   default sessiontype=foo... but foo is absent from sessiontypes line?
                      Similarly, whatif default line contains a comma (or mid-word space)?
    * Grrrrrr     cust1-5  must be INT values (needs documented)
                 temporarily removed conditional from
                 ShowCust5mesg()
    *   ax21alpha   lacks a unicode font substitute for "Verdana"
           ^---> renders TOFU  (so, choose another fontname?)
    * RECHECK:    do I need to add    Depends: libpam-elogind | logind
          within  debian/conrol
    * TODO       retest  to ensure each of the stretch/center/tile/solidcolor modes works correctly
    * patch applied to handle case   PAM_ACCT_EXPIRED
    *  noted:  https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=537604
        security bug, if root-permssioned scrot command specifies output
        to a /tmp/* destination (and a bad actor has symlinked the {known} destination file)
    * changed seemingly innocuous name "screenshot_cmd", to "F11_cmd"
      and added a 'security considerations' note in the conf, the manpage, the readme
    * slimski is hardcoded to reject (prohibit) 'root' user account login
    * TODO    re-verify   does  App::AuthenticateUser (or elsewhere) demand root pw?
    * NEED TO TEST
       whatif both a background.jpg AND a background.PNG file are found in a given theme directory?
       (also, same Q regarding panel jpg/png)

 -- skidoo <email@redact.ed>  Fri, 01 Jan 2021 12:34:56 +0100

slimski (1.4.3) unstable; urgency=medium

    * interim version for internal testing

 -- skidoo <email@redact.ed>  Mon, 18 Mar 2018 12:34:56 +0100

slimski (1.4.2) unstable; urgency=medium

    * added UTF8 support for welcome_message
        (translations followup needed)
    * debian/rules: add hardening rules
        (source fortification, stack protection, relro)
    * remove unused jpeg.c and png.c, and refs within CMakeLists.txt
        Their functionality had already been incorporated into image.cpp
    * app.cpp:  Fix env alloc (ref http://bugs.debian.org/733916)
    * image.cpp, image.h: outcomment unused fn Merge_non_crop()
    * add new options to support centering of input box text and hiding of cursor


=== debian/control ===
Source: slimski
Section: x11
Priority: optional
Maintainer: skidoo <email@redact.ed>
Build-Depends: debconf, debhelper (>= 9.20151219), dh-exec, po-debconf, sharutils,
    cmake, libpam0g-dev, libjpeg-dev, libpng-dev, libxft-dev, libxmu-dev
Standards-Version: 3.9.8
Homepage: https://gitlab.com/skidoo/slimski

Package: slimski
Architecture: any
Provides: x-display-manager
Recommends: xvkbd, scrot
Suggests: xauth
Depends: ${shlibs:Depends}, ${misc:Depends}, debconf (>= 1.2.9) | debconf-2.0,
    default-logind | logind | consolekit
Description: desktop-independent graphical login manager for X11
 .
 slimski enables users to initializate a graphical session by entering
 username and password in a login screen.
 slimski is configurable via themes and via an options (conf) file.
 It is suitable for machines that do not require remote logins.
